Index: drivers/dahdi/dahdi-base.c
===================================================================
--- drivers/dahdi/dahdi-base.c	(revision 7107)
+++ drivers/dahdi/dahdi-base.c	(working copy)
@@ -2842,77 +3247,72 @@
 }
 #endif
 
-static ssize_t dahdi_read(struct file *file, char *usrbuf, size_t count, loff_t *ppos)
+static read_retval_t dahdi_read(FOP_READ_ARGS_DECL)
 {
 	int unit = UNIT(file);
 	struct dahdi_chan *chan;
 
 	/* Can't read from control */
 	if (!unit) {
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
-	if (unit == 253)
-		return -EINVAL;
+	if (unit == DAHDI_MINOR_TIMER)
+		return _RETVAL(EINVAL);
 
-	if (unit == 254) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_CHANNEL) {
+		chan = dahdi_get_private_data(file);
 		if (!chan)
-			return -EINVAL;
-		return dahdi_chan_read(file, usrbuf, count, chan->channo);
+			return _RETVAL(EINVAL);
+		return dahdi_chan_read(FOP_READ_ARGS, chan->channo);
 	}
 
-	if (unit == 255) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_PSEUDO) {
+		chan = dahdi_get_private_data(file);
 		if (!chan) {
 			module_printk(KERN_NOTICE, "No pseudo channel structure to read?\n");
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
-		return dahdi_chan_read(file, usrbuf, count, chan->channo);
+		return dahdi_chan_read(FOP_READ_ARGS, chan->channo);
 	}
-	if (count < 0)
-		return -EINVAL;
 
-	return dahdi_chan_read(file, usrbuf, count, unit);
+	return dahdi_chan_read(FOP_READ_ARGS, unit);
 }
 
-static ssize_t dahdi_write(struct file *file, const char *usrbuf, size_t count, loff_t *ppos)
+static write_retval_t dahdi_write(FOP_WRITE_ARGS_DECL)
 {
 	int unit = UNIT(file);
 	struct dahdi_chan *chan;
 	/* Can't read from control */
 	if (!unit)
-		return -EINVAL;
-	if (count < 0)
-		return -EINVAL;
-	if (unit == 253)
-		return -EINVAL;
-	if (unit == 254) {
-		chan = file->private_data;
+		return _RETVAL(EINVAL);
+	if (unit == DAHDI_MINOR_TIMER)
+		return _RETVAL(EINVAL);
+	if (unit == DAHDI_MINOR_CHANNEL) {
+		chan = dahdi_get_private_data(file);
 		if (!chan)
-			return -EINVAL;
-		return dahdi_chan_write(file, usrbuf, count, chan->channo);
+			return _RETVAL(EINVAL);
+		return dahdi_chan_write(FOP_WRITE_ARGS, chan->channo);
 	}
-	if (unit == 255) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_PSEUDO) {
+		chan = dahdi_get_private_data(file);
 		if (!chan) {
 			module_printk(KERN_NOTICE, "No pseudo channel structure to read?\n");
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
-		return dahdi_chan_write(file, usrbuf, count, chan->channo);
+		return dahdi_chan_write(FOP_WRITE_ARGS, chan->channo);
 	}
-	return dahdi_chan_write(file, usrbuf, count, unit);
-
+	return dahdi_chan_write(FOP_WRITE_ARGS, unit);
 }
 
 static int dahdi_set_default_zone(int defzone)
 {
 	if ((defzone < 0) || (defzone >= DAHDI_TONE_ZONE_MAX))
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	write_lock(&zone_lock);
 	if (!tone_zones[defzone]) {
 		write_unlock(&zone_lock);
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 	if ((default_zone != -1) && tone_zones[default_zone])
 		atomic_dec(&tone_zones[default_zone]->refcount);
@@ -2933,7 +3333,7 @@
    format is much simpler (an array structure field of the zone
    structure, rather an array of pointers).
 */
-static int ioctl_load_zone(unsigned long data)
+static int ioctl_load_zone(FOP_IOCTL_ARGS_DECL)
 {
 	struct load_zone_workarea {
 		struct dahdi_tone *samples[MAX_TONES];
@@ -2952,12 +3352,16 @@
 
 	work = kzalloc(sizeof(*work), GFP_KERNEL);
 	if (!work)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
-	if (copy_from_user(&work->th, (struct dahdi_tone_def_header *)data,
-	    sizeof(work->th))) {
+#if defined(__FreeBSD__)
+	bcopy(data, &data, sizeof(void *));
+	if (copyin(data, &work->th, sizeof(work->th))) {
+#else
+	if (copy_from_user(&work->th, (struct dahdi_tone_def_header *)data, sizeof(work->th))) {
+#endif
 		kfree(work);
-		return -EFAULT;
+		return _RETVAL(EFAULT);
 	}
 
 	data += sizeof(work->th);
@@ -2965,23 +3369,23 @@
 	if ((work->th.count < 0) || (work->th.count > MAX_TONES)) {
 		module_printk(KERN_NOTICE, "Too many tones included\n");
 		kfree(work);
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	space = size = sizeof(*z) + work->th.count * sizeof(*t);
 
 	if (size > MAX_SIZE) {
 		kfree(work);
-		return -E2BIG;
+		return _RETVAL(E2BIG);
 	}
 
 	z = ptr = slab = kzalloc(size, GFP_KERNEL);
 	if (!z) {
 		kfree(work);
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 	}
 
-	ptr += sizeof(*z);
+	ptr = (char *) ptr + sizeof(*z);
 	space -= sizeof(*z);
 
 	dahdi_copy_string(z->name, work->th.name, sizeof(z->name));
@@ -3004,15 +3408,18 @@
 			kfree(slab);
 			kfree(work);
 			module_printk(KERN_NOTICE, "Insufficient tone zone space\n");
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
 
-		res = copy_from_user(&work->td, (struct dahdi_tone_def *)data,
-				     sizeof(work->td));
+#if defined(__FreeBSD__)
+		res = copyin(data, &work->td, sizeof(work->td));
+#else
+		res = copy_from_user(&work->td, (struct dahdi_tone_def *)data, sizeof(work->td));
+#endif
 		if (res) {
 			kfree(slab);
 			kfree(work);
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		}
 
 		data += sizeof(work->td);
@@ -3023,7 +3430,7 @@
 			t = work->samples[x] = ptr;
 
 			space -= sizeof(*t);
-			ptr += sizeof(*t);
+			ptr = (char *) ptr + sizeof(*t);
 
 			/* Remember which sample is work->next */
 			work->next[x] = work->td.next;
@@ -3036,7 +3443,7 @@
 					      work->next[x]);
 				kfree(slab);
 				kfree(work);
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			}
 		} else if ((work->td.tone >= DAHDI_TONE_DTMF_BASE) &&
 			   (work->td.tone <= DAHDI_TONE_DTMF_MAX)) {
@@ -3064,7 +3471,7 @@
 				      work->td.tone);
 			kfree(slab);
 			kfree(work);
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
 
 		t->fac1 = work->td.fac1;
@@ -3340,6 +3747,7 @@
 				chan->tonep = 0;
 				if (chan->curtone) {
 					dahdi_init_tone_state(&chan->ts, chan->curtone);
+
 					return;
 				}
 			}
@@ -3351,47 +3759,50 @@
 	__qevent(chan, DAHDI_EVENT_DIALCOMPLETE);
 }
 
-static int dahdi_release(struct inode *inode, struct file *file)
+static int dahdi_release(FOP_CLOSE_ARGS_DECL)
 {
 	int unit = UNIT(file);
 	int res;
 	struct dahdi_chan *chan;
 
-	if (!unit)
-		return dahdi_ctl_release(inode, file);
-	if (unit == 253) {
-		return dahdi_timer_release(inode, file);
-	}
-	if (unit == 250) {
+	if (!unit) {
+		res = dahdi_ctl_release(FOP_ARGS);
+	} else if (unit == DAHDI_MINOR_TIMER) {
+		res = dahdi_timer_release(FOP_ARGS);
+	} else if (unit == DAHDI_MINOR_TRANSCODE) {
 		/* We should not be here because the dahdi_transcode.ko module
 		 * should have updated the file_operations for this file
 		 * handle when the file was opened. */
 		WARN_ON(1);
-		return -EFAULT;
-	}
-	if (unit == 254) {
-		chan = file->private_data;
+		res = _RETVAL(EFAULT);
+	} else if (unit == DAHDI_MINOR_CHANNEL) {
+		chan = dahdi_get_private_data(file);
 		if (!chan)
-			return dahdi_chan_release(inode, file);
+			res = dahdi_chan_release(FOP_ARGS);
 		else
-			return dahdi_specchan_release(inode, file, chan->channo);
-	}
-	if (unit == 255) {
-		chan = file->private_data;
+			res = dahdi_specchan_release(FOP_ARGS, chan->channo);
+	} else if (unit == DAHDI_MINOR_PSEUDO) {
+		chan = dahdi_get_private_data(file);
 		if (chan) {
-			res = dahdi_specchan_release(inode, file, chan->channo);
+			res = dahdi_specchan_release(FOP_ARGS, chan->channo);
 			dahdi_free_pseudo(chan);
 		} else {
 			module_printk(KERN_NOTICE, "Pseudo release and no private data??\n");
 			res = 0;
 		}
-		return res;
+	} else {
+		res = dahdi_specchan_release(FOP_ARGS, unit);
 	}
-	return dahdi_specchan_release(inode, file, unit);
+
+#if defined(__FreeBSD__)
+	if (res == 0)
+		devfs_clear_cdevpriv();
+#endif
+	return (res);
 }
 
 #if 0
-static int dahdi_release(struct inode *inode, struct file *file)
+static int dahdi_release(FOP_CLOSE_ARGS)
 {
 	/* Lock the big zap lock when handling a release */
 	unsigned long flags;
@@ -3446,26 +3857,26 @@
 
 #define VALID_SPAN(j) do { \
 	if ((j >= DAHDI_MAX_SPANS) || (j < 1)) \
-		return -EINVAL; \
+		return _RETVAL(EINVAL); \
 	if (!spans[j]) \
-		return -ENXIO; \
+		return _RETVAL(ENXIO); \
 } while(0)
 
 #define CHECK_VALID_SPAN(j) do { \
 	/* Start a given span */ \
 	if (get_user(j, (int *)data)) \
-		return -EFAULT; \
+		return _RETVAL(EFAULT); \
 	VALID_SPAN(j); \
 } while(0)
 
 #define VALID_CHANNEL(j) do { \
 	if ((j >= DAHDI_MAX_CHANNELS) || (j < 1)) \
-		return -EINVAL; \
+		return _RETVAL(EINVAL); \
 	if (!chans[j]) \
-		return -ENXIO; \
+		return _RETVAL(ENXIO); \
 } while(0)
 
-static int dahdi_timer_ioctl(struct inode *node, struct file *file, unsigned int cmd, unsigned long data, struct dahdi_timer *timer)
+static int dahdi_timer_ioctl(FOP_IOCTL_ARGS_DECL, struct dahdi_timer * timer)
 {
 	int j;
 	unsigned long flags;
@@ -3500,7 +3911,11 @@
 	case DAHDI_TIMERPING:
 		spin_lock_irqsave(&zaptimerlock, flags);
 		timer->ping = 1;
+#if defined(__FreeBSD__)
+		taskqueue_enqueue_fast(taskqueue_fast, &timer->selwakeup_task);
+#else
 		wake_up_interruptible(&timer->sel);
+#endif
 		spin_unlock_irqrestore(&zaptimerlock, flags);
 		break;
 	case DAHDI_TIMERPONG:
@@ -3509,13 +3924,12 @@
 		spin_unlock_irqrestore(&zaptimerlock, flags);
 		break;
 	default:
-		return -ENOTTY;
+		return _RETVAL(ENOTTY);
 	}
 	return 0;
 }
 
-static int dahdi_ioctl_getgains(struct inode *node, struct file *file,
-				unsigned int cmd, unsigned long data, int unit)
+static int dahdi_ioctl_getgains(FOP_IOCTL_ARGS_DECL, int unit)
 {
 	int res = 0;
 	struct dahdi_gains *gain;
@@ -3559,8 +3973,7 @@
 	return 0;
 }
 
-static int dahdi_ioctl_setgains(struct inode *node, struct file *file,
-				unsigned int cmd, unsigned long data, int unit)
+static int dahdi_ioctl_setgains(FOP_IOCTL_ARGS_DECL, int unit)
 {
 	int res = 0;
 	struct dahdi_gains *gain;
@@ -3636,7 +4049,7 @@
 	return 0;
 }
 
-static int dahdi_common_ioctl(struct inode *node, struct file *file, unsigned int cmd, unsigned long data, int unit)
+static int dahdi_common_ioctl(FOP_IOCTL_ARGS_DECL, int unit)
 {
 	union {
 		struct dahdi_spaninfo spaninfo;
@@ -3654,7 +4067,7 @@
 	case DAHDI_GET_PARAMS:
 		size_to_copy = sizeof(struct dahdi_params);
 		if (copy_from_user(&stack.param, (struct dahdi_params *) data, size_to_copy))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 
 		/* check to see if the caller wants to receive our master channel number */
 		if (stack.param.channo & DAHDI_GET_PARAMS_RETURN_MASTER) {
@@ -3732,13 +4145,13 @@
 			stack.param.curlaw = DAHDI_LAW_MULAW;
 
 		if (copy_to_user((struct dahdi_params *) data, &stack.param, size_to_copy))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 
 		break;
 		/* set channel parameters */
 	case DAHDI_SET_PARAMS:
 		if (copy_from_user(&stack.param, (struct dahdi_params *) data, sizeof(struct dahdi_params)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 
 		stack.param.chan_alarms = 0; /* be explicit about the above */
 
@@ -3769,23 +4182,23 @@
 		break;
 	case DAHDI_GETGAINS_V1: /* Intentional drop through. */
 	case DAHDI_GETGAINS:  /* get gain stuff */
-		return dahdi_ioctl_getgains(node, file, cmd, data, unit);
+		return dahdi_ioctl_getgains(FOP_IOCTL_ARGS, unit);
 	case DAHDI_SETGAINS:  /* set gain stuff */
-		return dahdi_ioctl_setgains(node, file, cmd, data, unit);
+		return dahdi_ioctl_setgains(FOP_IOCTL_ARGS, unit);
 	case DAHDI_SPANSTAT:
 		size_to_copy = sizeof(struct dahdi_spaninfo);
 		if (copy_from_user(&stack.spaninfo, (struct dahdi_spaninfo *) data, size_to_copy))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		i = stack.spaninfo.spanno; /* get specified span number */
-		if ((i < 0) || (i >= maxspans)) return(-EINVAL);  /* if bad span no */
+		if ((i < 0) || (i >= maxspans)) return(_RETVAL(EINVAL));  /* if bad span no */
 		if (i == 0) {
 			/* if to figure it out for this chan */
 			if (!chans[unit])
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			i = chans[unit]->span->spanno;
 		}
 		if (!spans[i])
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		stack.spaninfo.spanno = i; /* put the span # in here */
 		stack.spaninfo.totalspans = 0;
 		if (maxspans) stack.spaninfo.totalspans = maxspans - 1; /* put total number of spans here */
@@ -3821,7 +4234,7 @@
 			dahdi_copy_string(stack.spaninfo.spantype, spans[i]->spantype, sizeof(stack.spaninfo.spantype));
 
 		if (copy_to_user((struct dahdi_spaninfo *) data, &stack.spaninfo, size_to_copy))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		break;
 	case DAHDI_CHANDIAG_V1: /* Intentional drop through. */
 	case DAHDI_CHANDIAG:
@@ -3835,14 +4248,14 @@
 		get_user(j, (int *) data); /* get channel number from user */
 		/* make sure its a valid channel number */
 		if ((j < 1) || (j >= maxchans))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		/* if channel not mapped, not there */
 		if (!chans[j])
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 
 		chan = kmalloc(sizeof(*chan), GFP_KERNEL);
 		if (!chan)
-			return -ENOMEM;
+			return _RETVAL(ENOMEM);
 
 		/* lock channel */
 		spin_lock_irqsave(&chans[j]->lock, flags);
@@ -3887,7 +4300,7 @@
 		break;
 	}
 	default:
-		return -ENOTTY;
+		return _RETVAL(ENOTTY);
 	}
 	return 0;
 }
@@ -3936,7 +4349,7 @@
 #endif
 }
 
-static int dahdi_ctl_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long data)
+static int dahdi_ctl_ioctl(FOP_IOCTL_ARGS_DECL)
 {
 	/* I/O CTL's for control interface */
 	int i,j;
@@ -3952,19 +4365,19 @@
 		struct dahdi_indirect_data ind;
 
 		if (copy_from_user(&ind, (struct dahdi_indirect_data *)data, sizeof(ind)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		VALID_CHANNEL(ind.chan);
-		return dahdi_chan_ioctl(inode, file, ind.op, (unsigned long) ind.data, ind.chan);
+		return dahdi_chan_ioctl(FOP_IOCTL_ARGS, ind.chan);
 	}
 	case DAHDI_SPANCONFIG:
 	{
 		struct dahdi_lineconfig lc;
 
 		if (copy_from_user(&lc, (struct dahdi_lineconfig *)data, sizeof(lc)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		VALID_SPAN(lc.span);
 		if ((lc.lineconfig & 0x07f0 & spans[lc.span]->linecompat) != (lc.lineconfig & 0x07f0))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (spans[lc.span]->spanconfig) {
 			spans[lc.span]->lineconfig = lc.lineconfig;
 			spans[lc.span]->lbo = lc.lbo;
@@ -4015,7 +4428,7 @@
 		const struct dahdi_echocan_factory *new = NULL, *old;
 
 		if (copy_from_user(&ae, (struct dahdi_attach_echocan *) data, sizeof(ae))) {
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		}
 
 		VALID_CHANNEL(ae.chan);
@@ -4023,7 +4436,7 @@
 		ae.echocan[sizeof(ae.echocan) - 1] = 0;
 		if (ae.echocan[0]) {
 			if (!(new = find_echocan(ae.echocan))) {
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			}
 		}
 
@@ -4043,22 +4456,22 @@
 		struct dahdi_chanconfig ch;
 
 		if (copy_from_user(&ch, (struct dahdi_chanconfig *)data, sizeof(ch)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		VALID_CHANNEL(ch.chan);
 		if (ch.sigtype == DAHDI_SIG_SLAVE) {
 			/* We have to use the master's sigtype */
 			if ((ch.master < 1) || (ch.master >= DAHDI_MAX_CHANNELS))
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			if (!chans[ch.master])
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			ch.sigtype = chans[ch.master]->sig;
 			newmaster = chans[ch.master];
 		} else if ((ch.sigtype & __DAHDI_SIG_DACS) == __DAHDI_SIG_DACS) {
 			newmaster = chans[ch.chan];
 			if ((ch.idlebits < 1) || (ch.idlebits >= DAHDI_MAX_CHANNELS))
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			if (!chans[ch.idlebits])
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 		} else {
 			newmaster = chans[ch.chan];
 		}
@@ -4068,7 +4481,7 @@
 			if (ztchan_to_dev(chans[ch.chan])->flags & IFF_UP) {
 				spin_unlock_irqrestore(&chans[ch.chan]->lock, flags);
 				module_printk(KERN_WARNING, "Can't switch HDLC net mode on channel %s, since current interface is up\n", chans[ch.chan]->name);
-				return -EBUSY;
+				return _RETVAL(EBUSY);
 			}
 			spin_unlock_irqrestore(&chans[ch.chan]->lock, flags);
 			unregister_hdlc_device(chans[ch.chan]->hdlcnetdev->netdev);
@@ -4082,7 +4495,7 @@
 		if (ch.sigtype == DAHDI_SIG_HDLCNET) {
 			spin_unlock_irqrestore(&chans[ch.chan]->lock, flags);
 			module_printk(KERN_WARNING, "DAHDI networking not supported by this build.\n");
-			return -ENOSYS;
+			return _RETVAL(ENOSYS);
 		}
 #endif
 		sigcap = chans[ch.chan]->sigcap;
@@ -4092,7 +4505,7 @@
 			sigcap |= (DAHDI_SIG_HDLCRAW | DAHDI_SIG_HDLCFCS | DAHDI_SIG_HDLCNET | DAHDI_SIG_DACS);
 
 		if ((sigcap & ch.sigtype) != ch.sigtype)
-			res = -EINVAL;
+			res = _RETVAL(EINVAL);
 
 		if (!res && chans[ch.chan]->span->chanconfig)
 			res = chans[ch.chan]->span->chanconfig(chans[ch.chan], ch.sigtype);
@@ -4215,7 +4628,7 @@
 			/* Copy back any modified settings */
 			spin_unlock_irqrestore(&chans[ch.chan]->lock, flags);
 			if (copy_to_user((struct dahdi_chanconfig *)data, &ch, sizeof(ch)))
-				return -EFAULT;
+				return _RETVAL(EFAULT);
 			spin_lock_irqsave(&chans[ch.chan]->lock, flags);
 			/* And hangup */
 			dahdi_hangup(chans[ch.chan]);
@@ -4236,9 +4649,9 @@
 		struct dahdi_sfconfig sf;
 
 		if (copy_from_user(&sf, (struct dahdi_chanconfig *)data, sizeof(sf)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		VALID_CHANNEL(sf.chan);
-		if (chans[sf.chan]->sig != DAHDI_SIG_SF) return -EINVAL;
+		if (chans[sf.chan]->sig != DAHDI_SIG_SF) return _RETVAL(EINVAL);
 		spin_lock_irqsave(&chans[sf.chan]->lock, flags);
 		chans[sf.chan]->rxp1 = sf.rxp1;
 		chans[sf.chan]->rxp2 = sf.rxp2;
@@ -4264,10 +4677,10 @@
 	}
 	case DAHDI_DEFAULTZONE:
 		if (get_user(j,(int *)data))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		return dahdi_set_default_zone(j);
 	case DAHDI_LOADZONE:
-		return ioctl_load_zone(data);
+		return ioctl_load_zone(FOP_IOCTL_ARGS);
 	case DAHDI_FREEZONE:
 		get_user(j, (int *) data);
 		return free_tone_zone(j);
@@ -4276,7 +4689,7 @@
 		struct dahdi_dialparams tdp;
 
 		if (copy_from_user(&tdp, (struct dahdi_dialparams *) data, sizeof(tdp)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 
 		if ((tdp.dtmf_tonelen >= 10) && (tdp.dtmf_tonelen <= 4000)) {
 			global_dialparams.dtmf_tonelen = tdp.dtmf_tonelen;
@@ -4327,7 +4740,7 @@
 
 		tdp = global_dialparams;
 		if (copy_to_user((struct dahdi_dialparams *) data, &tdp, sizeof(tdp)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		break;
 	}
 	case DAHDI_GETVERSION:
@@ -4355,7 +4768,7 @@
 		}
 		read_unlock(&ecfactory_list_lock);
 		if (copy_to_user((struct dahdi_versioninfo *) data, &vi, sizeof(vi)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		break;
 	}
 	case DAHDI_MAINT:  /* do maintenance stuff */
@@ -4363,12 +4776,12 @@
 		struct dahdi_maintinfo maint;
 		  /* get struct from user */
 		if (copy_from_user(&maint,(struct dahdi_maintinfo *) data, sizeof(maint)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		/* must be valid span number */
 		if ((maint.spanno < 1) || (maint.spanno > DAHDI_MAX_SPANS) || (!spans[maint.spanno]))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (!spans[maint.spanno]->maint)
-			return -ENOSYS;
+			return _RETVAL(ENOSYS);
 		spin_lock_irqsave(&spans[maint.spanno]->lock, flags);
 		  /* save current maint state */
 		i = spans[maint.spanno]->maintstat;
@@ -4409,30 +4822,30 @@
 	case DAHDI_DYNAMIC_CREATE:
 	case DAHDI_DYNAMIC_DESTROY:
 		if (dahdi_dynamic_ioctl) {
-			return dahdi_dynamic_ioctl(cmd, data);
+			return dahdi_dynamic_ioctl(cmd, (u_long) data);
 		} else {
 			request_module("dahdi_dynamic");
 			if (dahdi_dynamic_ioctl)
-				return dahdi_dynamic_ioctl(cmd, data);
+				return dahdi_dynamic_ioctl(cmd, (u_long) data);
 		}
-		return -ENOSYS;
+		return _RETVAL(ENOSYS);
 	case DAHDI_EC_LICENSE_CHALLENGE:
 	case DAHDI_EC_LICENSE_RESPONSE:
 		if (dahdi_hpec_ioctl) {
-			return dahdi_hpec_ioctl(cmd, data);
+			return dahdi_hpec_ioctl(cmd, (u_long) data);
 		} else {
 			request_module("dahdi_echocan_hpec");
 			if (dahdi_hpec_ioctl)
-				return dahdi_hpec_ioctl(cmd, data);
+				return dahdi_hpec_ioctl(cmd, (u_long) data);
 		}
-		return -ENOSYS;
+		return _RETVAL(ENOSYS);
 	default:
-		return dahdi_common_ioctl(inode, file, cmd, data, 0);
+		return dahdi_common_ioctl(FOP_IOCTL_ARGS, 0);
 	}
 	return 0;
 }
 
-static int ioctl_dahdi_dial(struct dahdi_chan *chan, unsigned long data)
+static int ioctl_dahdi_dial(FOP_IOCTL_ARGS_DECL, struct dahdi_chan *chan)
 {
 	struct dahdi_dialoperation *tdo;
 	unsigned long flags;
@@ -4440,12 +4853,11 @@
 	int rv;
 
 	tdo = kmalloc(sizeof(*tdo), GFP_KERNEL);
-
 	if (!tdo)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	if (copy_from_user(tdo, (struct dahdi_dialoperation *)data, sizeof(*tdo)))
-		return -EFAULT;
+		return _RETVAL(EFAULT);
 	rv = 0;
 	/* Force proper NULL termination and uppercase entry */
 	tdo->dialstr[DAHDI_MAX_DTMF_BUF - 1] = '\0';
@@ -4456,7 +4868,7 @@
 		spin_unlock_irqrestore(&chan->lock, flags);
 		/* The tone zones are loaded by dahdi_cfg from /etc/dahdi/system.conf */
 		module_printk(KERN_WARNING, "Cannot dial until a tone zone is loaded.\n");
-		return -ENODATA;
+		return _RETVAL(ENODATA);
 	}
 	switch (tdo->op) {
 	case DAHDI_DIAL_OP_CANCEL:
@@ -4473,7 +4885,7 @@
 		break;
 	case DAHDI_DIAL_OP_APPEND:
 		if (strlen(tdo->dialstr) + strlen(chan->txdialbuf) >= (DAHDI_MAX_DTMF_BUF - 1)) {
-			rv = -EBUSY;
+			rv = _RETVAL(EBUSY);
 			break;
 		}
 		dahdi_copy_string(chan->txdialbuf + strlen(chan->txdialbuf), tdo->dialstr, DAHDI_MAX_DTMF_BUF - strlen(chan->txdialbuf));
@@ -4483,13 +4895,13 @@
 		}
 		break;
 	default:
-		rv = -EINVAL;
+		rv = _RETVAL(EINVAL);
 	}
 	spin_unlock_irqrestore(&chan->lock, flags);
 	return rv;
 }
 
-static int dahdi_chanandpseudo_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long data, int unit)
+static int dahdi_chanandpseudo_ioctl(FOP_IOCTL_ARGS_DECL, int unit)
 {
 	struct dahdi_chan *chan = chans[unit];
 	union {
@@ -4502,17 +4914,17 @@
 	int ret, c;
 
 	if (!chan)
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	switch(cmd) {
 	case DAHDI_DIALING:
 		spin_lock_irqsave(&chan->lock, flags);
 		j = chan->dialing;
 		spin_unlock_irqrestore(&chan->lock, flags);
 		if (copy_to_user((int *)data,&j,sizeof(int)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		return 0;
 	case DAHDI_DIAL:
-		return ioctl_dahdi_dial(chan, data);
+		return ioctl_dahdi_dial(FOP_IOCTL_ARGS, chan);
 	case DAHDI_GET_BUFINFO:
 		memset(&stack.bi, 0, sizeof(stack.bi));
 		stack.bi.rxbufpolicy = chan->rxbufpolicy;
@@ -4523,17 +4935,17 @@
 		stack.bi.readbufs = -1;
 		stack.bi.writebufs = -1;
 		if (copy_to_user((struct dahdi_bufferinfo *)data, &stack.bi, sizeof(stack.bi)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		break;
 	case DAHDI_SET_BUFINFO:
 		if (copy_from_user(&stack.bi, (struct dahdi_bufferinfo *)data, sizeof(stack.bi)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		if (stack.bi.bufsize > DAHDI_MAX_BLOCKSIZE)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (stack.bi.bufsize < 16)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (stack.bi.bufsize * stack.bi.numbufs > DAHDI_MAX_BUF_SPACE)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		/* It does not make sense to allow user mode to change the
 		 * receive buffering policy.  DAHDI always provides received
 		 * buffers to upper layers immediately.  Transmission is
@@ -4550,9 +4962,9 @@
 	case DAHDI_SET_BLOCKSIZE:  /* set blocksize */
 		get_user(j,(int *)data);
 		  /* cannot be larger than max amount */
-		if (j > DAHDI_MAX_BLOCKSIZE) return(-EINVAL);
+		if (j > DAHDI_MAX_BLOCKSIZE) return(_RETVAL(EINVAL));
 		  /* cannot be less then 16 */
-		if (j < 16) return(-EINVAL);
+		if (j < 16) return(_RETVAL(EINVAL));
 		  /* allocate a single kernel buffer which we then
 		     sub divide into four pieces */
 		if ((rv = dahdi_reallocbufs(chan, j, chan->numbufs)))
@@ -4572,7 +4984,11 @@
 				chan->readidx[j] = 0;
 			}
 			wake_up_interruptible(&chan->readbufq);  /* wake_up_interruptible waiting on read */
+#if defined(__FreeBSD__)
+			taskqueue_enqueue_fast(taskqueue_fast, &chan->selwakeup_task);
+#else
 			wake_up_interruptible(&chan->sel); /* wake_up_interruptible waiting on select */
+#endif
 		   }
 		if (i & DAHDI_FLUSH_WRITE) /* if for write (output) */
 		   {
@@ -4585,7 +5001,11 @@
 				chan->writeidx[j] = 0;
 			}
 			wake_up_interruptible(&chan->writebufq); /* wake_up_interruptible waiting on write */
+#if defined(__FreeBSD__)
+			taskqueue_enqueue_fast(taskqueue_fast, &chan->selwakeup_task);
+#else
 			wake_up_interruptible(&chan->sel);  /* wake_up_interruptible waiting on select */
+#endif
 			   /* if IO MUX wait on write empty, well, this
 				certainly *did* empty the write */
 			if (chan->iomask & DAHDI_IOMUX_WRITEEMPTY)
@@ -4612,7 +5032,7 @@
 		break;
 	case DAHDI_IOMUX: /* wait for something to happen */
 		get_user(chan->iomask,(int*)data);  /* save mask */
-		if (!chan->iomask) return(-EINVAL);  /* cant wait for nothing */
+		if (!chan->iomask) return(_RETVAL(EINVAL));  /* cant wait for nothing */
 		for(;;)  /* loop forever */
 		   {
 			  /* has to have SOME mask */
@@ -4678,13 +5098,13 @@
 		break;
 	case DAHDI_CONFMUTE:  /* set confmute flag */
 		get_user(j,(int *)data);  /* get conf # */
-		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (-EINVAL);
+		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (_RETVAL(EINVAL));
 		spin_lock_irqsave(&bigzaplock, flags);
 		chan->confmute = j;
 		spin_unlock_irqrestore(&bigzaplock, flags);
 		break;
 	case DAHDI_GETCONFMUTE:  /* get confmute flag */
-		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (-EINVAL);
+		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (_RETVAL(EINVAL));
 		j = chan->confmute;
 		put_user(j,(int *)data);  /* get conf # */
 		rv = 0;
@@ -4709,29 +5129,29 @@
 	case DAHDI_GETCONF_V1: /* intentional drop through */
 	case DAHDI_GETCONF:  /* get conf stuff */
 		if (copy_from_user(&stack.conf,(struct dahdi_confinfo *) data,sizeof(stack.conf)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		i = stack.conf.chan;  /* get channel no */
 		   /* if zero, use current channel no */
 		if (!i) i = chan->channo;
 		  /* make sure channel number makes sense */
-		if ((i < 0) || (i > DAHDI_MAX_CONF) || (!chans[i])) return(-EINVAL);
-		if (!(chans[i]->flags & DAHDI_FLAG_AUDIO)) return (-EINVAL);
+		if ((i < 0) || (i > DAHDI_MAX_CONF) || (!chans[i])) return(_RETVAL(EINVAL));
+		if (!(chans[i]->flags & DAHDI_FLAG_AUDIO)) return (_RETVAL(EINVAL));
 		stack.conf.chan = i;  /* get channel number */
 		stack.conf.confno = chans[i]->confna;  /* get conference number */
 		stack.conf.confmode = chans[i]->confmode; /* get conference mode */
 		if (copy_to_user((struct dahdi_confinfo *) data,&stack.conf,sizeof(stack.conf)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		break;
 	case DAHDI_SETCONF_V1: /* Intentional fall through. */
 	case DAHDI_SETCONF:  /* set conf stuff */
 		if (copy_from_user(&stack.conf,(struct dahdi_confinfo *) data,sizeof(stack.conf)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		i = stack.conf.chan;  /* get channel no */
 		   /* if zero, use current channel no */
 		if (!i) i = chan->channo;
 		  /* make sure channel number makes sense */
-		if ((i < 1) || (i > DAHDI_MAX_CHANNELS) || (!chans[i])) return(-EINVAL);
-		if (!(chans[i]->flags & DAHDI_FLAG_AUDIO)) return (-EINVAL);
+		if ((i < 1) || (i > DAHDI_MAX_CHANNELS) || (!chans[i])) return(_RETVAL(EINVAL));
+		if (!(chans[i]->flags & DAHDI_FLAG_AUDIO)) return (_RETVAL(EINVAL));
 		if ((stack.conf.confmode & DAHDI_CONF_MODE_MASK) == DAHDI_CONF_MONITOR ||
 			(stack.conf.confmode & DAHDI_CONF_MODE_MASK) == DAHDI_CONF_MONITORTX ||
 			(stack.conf.confmode & DAHDI_CONF_MODE_MASK) == DAHDI_CONF_MONITORBOTH ||
@@ -4739,16 +5159,16 @@
 			(stack.conf.confmode & DAHDI_CONF_MODE_MASK) == DAHDI_CONF_MONITOR_TX_PREECHO ||
 			(stack.conf.confmode & DAHDI_CONF_MODE_MASK) == DAHDI_CONF_MONITORBOTH_PREECHO) {
 			/* Monitor mode -- it's a channel */
-			if ((stack.conf.confno < 0) || (stack.conf.confno >= DAHDI_MAX_CHANNELS) || !chans[stack.conf.confno]) return(-EINVAL);
+			if ((stack.conf.confno < 0) || (stack.conf.confno >= DAHDI_MAX_CHANNELS) || !chans[stack.conf.confno]) return(_RETVAL(EINVAL));
 		} else {
 			  /* make sure conf number makes sense, too */
-			if ((stack.conf.confno < -1) || (stack.conf.confno > DAHDI_MAX_CONF)) return(-EINVAL);
+			if ((stack.conf.confno < -1) || (stack.conf.confno > DAHDI_MAX_CONF)) return(_RETVAL(EINVAL));
 		}
 
 		  /* if taking off of any conf, must have 0 mode */
-		if ((!stack.conf.confno) && stack.conf.confmode) return(-EINVAL);
+		if ((!stack.conf.confno) && stack.conf.confmode) return(_RETVAL(EINVAL));
 		  /* likewise if 0 mode must have no conf */
-		if ((!stack.conf.confmode) && stack.conf.confno) return (-EINVAL);
+		if ((!stack.conf.confmode) && stack.conf.confno) return (_RETVAL(EINVAL));
 		stack.conf.chan = i;  /* return with real channel # */
 		spin_lock_irqsave(&bigzaplock, flags);
 		spin_lock(&chan->lock);
@@ -4758,7 +5178,7 @@
 			/* No more empty conferences */
 			spin_unlock(&chan->lock);
 			spin_unlock_irqrestore(&bigzaplock, flags);
-			return -EBUSY;
+			return _RETVAL(EBUSY);
 		}
 		  /* if changing confs, clear last added info */
 		if (stack.conf.confno != chans[i]->confna) {
@@ -4812,17 +5232,17 @@
 		spin_unlock(&chan->lock);
 		spin_unlock_irqrestore(&bigzaplock, flags);
 		if (copy_to_user((struct dahdi_confinfo *) data,&stack.conf,sizeof(stack.conf)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		break;
 	case DAHDI_CONFLINK:  /* do conf link stuff */
-		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (-EINVAL);
+		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (_RETVAL(EINVAL));
 		if (copy_from_user(&stack.conf,(struct dahdi_confinfo *) data,sizeof(stack.conf)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		  /* check sanity of arguments */
-		if ((stack.conf.chan < 0) || (stack.conf.chan > DAHDI_MAX_CONF)) return(-EINVAL);
-		if ((stack.conf.confno < 0) || (stack.conf.confno > DAHDI_MAX_CONF)) return(-EINVAL);
+		if ((stack.conf.chan < 0) || (stack.conf.chan > DAHDI_MAX_CONF)) return(_RETVAL(EINVAL));
+		if ((stack.conf.confno < 0) || (stack.conf.confno > DAHDI_MAX_CONF)) return(_RETVAL(EINVAL));
 		  /* cant listen to self!! */
-		if (stack.conf.chan && (stack.conf.chan == stack.conf.confno)) return(-EINVAL);
+		if (stack.conf.chan && (stack.conf.chan == stack.conf.confno)) return(_RETVAL(EINVAL));
 		spin_lock_irqsave(&bigzaplock, flags);
 		spin_lock(&chan->lock);
 		  /* if to clear all links */
@@ -4851,7 +5271,7 @@
 			   }
 			else /* if to add and already there, error */
 			   {
-				rv = -EEXIST;
+				rv = _RETVAL(EEXIST);
 			   }
 		   }
 		else  /* if not found */
@@ -4873,12 +5293,12 @@
 				   }
 				else /* if no empties -- error */
 				   {
-					rv = -ENOSPC;
+					rv = _RETVAL(ENOSPC);
 				   }
 			   }
 			else /* if to remove, and not found -- error */
 			   {
-				rv = -ENOENT;
+				rv = _RETVAL(ENOENT);
 			   }
 		   }
 		recalc_maxlinks();
@@ -4887,7 +5307,7 @@
 		return(rv);
 	case DAHDI_CONFDIAG_V1: /* Intention fall-through */
 	case DAHDI_CONFDIAG:  /* output diagnostic info to console */
-		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (-EINVAL);
+		if (!(chan->flags & DAHDI_FLAG_AUDIO)) return (_RETVAL(EINVAL));
 		get_user(j,(int *)data);  /* get conf # */
  		  /* loop thru the interesting ones */
 		for(i = ((j) ? j : 1); i <= ((j) ? j : DAHDI_MAX_CONF); i++)
@@ -4924,14 +5344,14 @@
 	case DAHDI_SETLAW:
 		get_user(j, (int *)data);
 		if ((j < 0) || (j > DAHDI_LAW_ALAW))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		dahdi_set_law(chan, j);
 		break;
 	case DAHDI_SETLINEAR:
 		get_user(j, (int *)data);
 		/* Makes no sense on non-audio channels */
 		if (!(chan->flags & DAHDI_FLAG_AUDIO))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 
 		if (j)
 			chan->flags |= DAHDI_FLAG_LINEAR;
